<?php
/**
 * @copyright  Copyright (c) 2018 Icredit 
 * @version 1.6.1
 * @author iCredit
*/

if (!defined('_PS_VERSION_'))
	exit;

class ICreditPaymentModuleFrontController extends ModuleFrontController
{
	# See FrontController::initContent()
	public function initContent()
	{

		$this->display_column_left = false;
		
		parent::initContent();

		$cart = $this->context->cart;
		if (!$this->module->checkCurrency($cart))
		{
			Tools::redirect('index.php?controller=order');
		}

		$title_module = Configuration::get('Title');
		
		
		# Get the currency id
		$id_currency = (int)$cart->id_currency;
		
		# Set the PrestaShop Smarty parameters
		$this->context->smarty->assign(array(
			'nbProducts' => $cart->nbProducts()
			, 'cust_currency' => $id_currency
			, 'title_module' => $title_module
			, 'currencies' => $this->module->getCurrency($id_currency)
			, 'total' => $cart->getOrderTotal(true, Cart::BOTH)
			, 'model_root_path' => $this->module->getPathUri()
			//, 'payments_list' => $payments_list
			//, 'installment_display' => $installment_display
		));


		# Display the template
		$this->setTemplate('payment_execution.tpl');
	}
}
