<?php
/**
 * @copyright  Copyright (c) 2018 Icredit 
 * @version 1.6.1
 * @author iCredit
*/

if (!defined('_PS_VERSION_'))
    exit;
class ICreditResponseModuleFrontController extends ModuleFrontController
{
    public function __construct()
    {
        parent::__construct();
    }

    public function postProcess()
    {
        $raw_post_data  = file_get_contents('php://input');
        $raw_post_array = explode('&', $raw_post_data);
        $IPNPost        = array();
        foreach ($raw_post_array as $keyval) {
            $keyval = explode('=', $keyval);
            if (count($keyval) == 2) {
                $IPNPost[$keyval[0]] = urldecode($keyval[1]);
            }
        }
        $sale_order_id = $IPNPost['Custom1'];
        $orderId       = $IPNPost['Order'];
        $sale_id       = $IPNPost['SaleId'];
        $amount        = $IPNPost['TransactionAmount'];
        $lang          = $IPNPost['Custom1'];
        if (Configuration::get('TestMode')) {
            $verify = 'https://testicredit.rivhit.co.il/API/PaymentPageRequest.svc/Verify';
            $token  = Configuration::get('TestGroupToken');
        } else {
            $verify = 'https://icredit.rivhit.co.il/API/PaymentPageRequest.svc/Verify';
            $token  = Configuration::get('ProdGroupToken');
            if($lang = 'en'){$token = Configuration::get('SecondProdGroupToken');}
        }
        
        $postData  = array(
            'GroupPrivateToken' => $token,
            'SaleId' => $IPNPost['SaleId'],
            'TotalAmount' => $IPNPost['TransactionAmount']
        );
        
        $verifyUrl = $verify;
        $jsonData  = json_encode($postData);
        $curl      = curl_init($verifyUrl);
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            "Content-type: application/json"
        ));
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $result   = curl_exec($curl);
        $response = json_decode($result);
        $Status   = $response->Status;
        curl_close($curl);

        if ($Status == 'VERIFIED') {
            $id_customer_icredit = Configuration::get('ICREDIT_CUSTOMER_ID');
            $cartid_icredit      = Configuration::get('ICREDIT_CART_ID');
            $customer            = new Customer($id_customer_icredit);
            $total               = Configuration::get('ICREDIT_ORDER_TOTAL');
            $currencyid_icredit  = Configuration::get('ICREDIT_CURRENCY_ID');
            $sql                 = "INSERT INTO " . _DB_PREFIX_ . "contact (`id_contact`, `email`, `customer_service`, `position`) VALUES ('','" . $currencyid_icredit . "' ,'" . $total . "','" . $customer->secure_key . "')";
            Db::getInstance()->execute($sql); # Create a order
            $this->module->validateOrder((int) $cartid_icredit, Configuration::get('OrderCreateStatus'), $total, $this->module->displayName, NULL, array(), (int) $currencyid_icredit, false, $customer->secure_key);
            $custom_last_order_id = Db::getInstance()->getValue('SELECT MAX(id_order) AS last_order_id FROM `' . _DB_PREFIX_ . 'orders`');
            $sql                  = "INSERT INTO " . _DB_PREFIX_ . "contact (`id_contact`, `email`, `customer_service`, `position`) VALUES ('','testing1',$custom_last_order_id,'4')";
            Db::getInstance()->execute($sql);
            if ($Status == 'VERIFIED') {
                if ($orderId != 0) {
                    $order             = new Order($custom_last_order_id);
                    $history           = new OrderHistory();
                    $history->id_order = (int) $order->id;
                    $history->changeIdOrderState(Configuration::get('PaidStatus'), $history->id_order);
                    $history->addWithemail();
                    $history->save();
                    $recvdarray = array();
                    $recvdarray = array(
                        'Status' => $Status,
                        'id_order' => $order->id,
                        'amount' => $amount
                    );
                    foreach ($recvdarray as $key => $values) {
                        Configuration::updateValue($key, $values);
                    }
                }
            } else {
                $order             = new Order($custom_last_order_id);
                $history           = new OrderHistory();
                $history->id_order = (int) $order->id;
                $history->changeIdOrderState((int) Configuration::get('UnpaidStatus'), $history->id_order);
                $history->addWithemail();
                $history->save();
                $recvdarray = array(
                    'Status' => 'Failed',
                    'id_order' => $order->id,
                    'amount' => $amount
                );
                foreach ($recvdarray as $key => $values) {
                    Configuration::updateValue($key, $values);
                }
            }
        }
    }
}
 
