<?php
/**
 * @copyright  Copyright (c) 2018 Icredit 
 * @version 1.6.1
 * @author iCredit
*/

if (!defined('_PS_VERSION_'))
	exit;

class ICreditValidationModuleFrontController extends ModuleFrontController
{
	public $ssl = true;
	public $display_column_left = false;

	public function postProcess()
	{	
		# Check the cart info

		$path = $this->module->getPathUri();
		
		$cart = $this->context->cart;
		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
		{
			Tools::redirect('index.php?controller=order&step=1');
		}
		
		# Check if the payment is available
		$authorized = false;
		foreach (Module::getPaymentModules() as $module)
		{
			if ($module['name'] == 'iCredit')
			{
				$authorized = true;
				break;
			}
		}
		if (!$authorized)
		{
			die($this->module->l('This payment method is not available', 'validation') . '.');
		}
		
		# Get the customer's info
		$customer = new Customer($cart->id_customer);
		if (!Validate::isLoadedObject($customer))
		{
			Tools::redirect('index.php?controller=order&step=1');
		}
		
		
		# Get the currency's info
		Configuration::updateValue('ICREDIT_CART_ID', (int)$cart->id);
		$currency = $this->context->currency;
		Configuration::updateValue('ICREDIT_CUSTOMER_ID',$cart->id_customer);
		//Configuration::updateValue('ICREDIT_CUSTOMER_SECUREKEY', $customer->secure_key);

		# Create a order
		$total = (float)$cart->getOrderTotal(true, Cart::BOTH);
		Configuration::updateValue('ICREDIT_ORDER_TOTAL', $total);
		Configuration::updateValue('ICREDIT_CURRENCY_ID', (int)$currency->id);
		//$this->module->validateOrder((int)$cart->id, Configuration::get('OrderCreateStatus'), $total, $this->module->displayName, NULL, array(), (int)$currency->id, false, $customer->secure_key);
		
		//$this->getdata();

		try
		{
			//$merchant_trade_no = $this->module->currentOrder;

			if (Configuration::get('TestMode'))
			{				
				$service_url = 'https://testicredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl';				
				$token = Configuration::get('TestGroupToken');				
			}
			else
			{
				$service_url = 'https://icredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl';
				$token = Configuration::get('ProdGroupToken');
			}

			if($this->context->language->iso_code == 'en' && Configuration::get('SecondProdGroupToken'))
			{
				$token = Configuration::get('SecondProdGroupToken');
			}

			# Set the product info of the order
			$cart_details = $cart->getSummaryDetails(null, true);	
			
			if(isset($cart_details['discounts'][0]['value_real']))
			{
				$discountvalue = @$cart_details['discounts'][0]['value_real'];
			}
			else
			{
				$discountvalue = $cart_details['total_discounts'];
			}
			
			$UnitPrice = $cart_details['total_price_without_tax'] - $cart_details['total_shipping_tax_exc'];
			//$cart->getTotalShippingCost()      getCartRules
			
			$product = $cart->getProducts();

			 //Order message 
			$comment = CustomerMessage::getMessagesByOrderId((int)$this->module->currentOrder, false);
			$Customercomment = @$comment[0]['message'];  
		
			foreach ($product as $product_info)
			{
					$items[]= array(
						'Id' => 0 ,
						'CatalogNumber' => $product_info['reference'], 
						'UnitPrice' => (float)$product_info['price'], 
						'Quantity' => $product_info['quantity'],
						'Description' => $product_info['name'] 
					);
			}	

			// Handle Shipping
			if(isset($cart_details))
			{
				$shipping_price = $cart_details['total_shipping_tax_exc'];
				$title = "Shipping";
				$items[]=array(
			    	  'Id'=>0,
			    	  'CatalogNumber' => '0',
			          'UnitPrice' => $shipping_price,
			          'Quantity' => 1,
			          'Description' => $title
	    	 	); 
			}		
			
			//other info
            if(Configuration::get('RedirectURL') == '')
            {
            	//$redirectURL = _PS_BASE_URL_.__PS_BASE_URI__.'module/iCredit/success';
            	$redirectURL = $this->context->link->getModuleLink('iCredit','success', array());
            }else{
            	$redirectURL = Configuration::get('RedirectURL');
            }

            //other info
            if(Configuration::get('IPNURL') == '')
            {
            	//$ipnURL = _PS_BASE_URL_.__PS_BASE_URI__.'module/iCredit/response';
            	$ipnURL = $this->context->link->getModuleLink('iCredit','response', array());
            }else{
            	$ipnURL = Configuration::get('IPNURL');
            }
			
            // HideItemList
			if(Configuration::get('HideItemsList') == 1)
			{
				$hideitemlist = false;
			}
			else
			{
				$hideitemlist = true;
			}

			if(Configuration::get('CreateToken') == 1)
			{
				$createtoken = true;
			}
			else
			{
				$createtoken = false;
			}

			// Getting city,postcodes & billing,shipping address..
	    	$customer_id = $this->context->customer->id;
      		$Query  = 'SELECT * FROM ps_address where id_customer = '.$customer_id;
			if ($results = Db::getInstance()->ExecuteS($Query))
	   		
	    	if(isset($results))
	    	{	    		    		
	    		$address1 = $results[0]['address1'];
	    		if($address1 == "")
	    		$address1 = $results[0]['address2'];	
		   		$city = $results[0]['city'];
		   		$postcode = $results[0]['postcode'];
		   		$phone_mobile = $results[count($results)-1]['phone_mobile'];
		   		if($phone_mobile == "")
		   		$phone_mobile = $results[count($results)-1]['phone'];

		   		//Shipping isocode

		   		$delivery_country_id = $results[0]['id_country'];
		   		$Query  = 'SELECT * FROM ps_country where id_country = '.$delivery_country_id;
				if ($isoCode = Db::getInstance()->ExecuteS($Query))
				$shipping_address_isocode = $isoCode[0]['iso_code'];					
		   		
		   		if(isset($results[1]))
		   		{
		   			$billing_country_id = $results[1]['id_country'];
		   			$Query  = 'SELECT * FROM ps_country where id_country = '.$billing_country_id;
					if ($isoCode = Db::getInstance()->ExecuteS($Query))
					$billing_address_isocode = $isoCode[0]['iso_code'];		
		   		}
		   		else
		   		{
					$billing_address_isocode = $shipping_address_isocode;
		   		}
		   		
		   	}	

			// Invoice language
 			$invoiceLanguageVal = '';
 			$invoiceLanguage = Configuration::get('InvoiceLanguage');
 				switch ($invoiceLanguage){
		      case "hebrew":
		        $invoiceLanguageVal="he";
		        break;
		      case "english":
		        $invoiceLanguageVal="en";
		        break;
		      case "billing":
		        if($billing_address_isocode=='IL'){
		          $invoiceLanguageVal="he";
		        }else{$invoiceLanguageVal="en";}
		        break;
		      case "shipping":
		        if($shipping_address_isocode=='IL'){
		          $invoiceLanguageVal="he";
		        }else{$invoiceLanguageVal="en";}
		        break;
		      case "billingorshipping":
		      if($shipping_address_isocode=='IL'OR $billing_address_isocode=='IL')
		      {
		        $invoiceLanguageVal="he";
		      }
		      else
		      {
		      	$invoiceLanguageVal="en";
		      }
		      break;
		      default:
		        $invoiceLanguageVal="en";
		      }


		     
		     $exemptVat = Configuration::get('ExemptVAT');
			 $exemptVatVal ='';    
			   //get Exempt Vat value//
			   switch ($exemptVat){
			      case "chargevat":
			        $exemptVatVal=false;
			        break;
			      case "exempt":
			         $exemptVatVal=true;
			        break;
			        case "billing":
		        if($billing_address_isocode=='IL'){
		          $exemptVatVal=false;
		        }else{$exemptVatVal=true;}
		        break;
		      case "shipping":
		        if($shipping_address_isocode=='IL'){
		          $exemptVatVal=false;
		        }else{$exemptVatVal=true;}
		        break;
		      case "billingorshipping":
		      if($shipping_address_isocode=='IL'OR $billing_address_isocode=='IL'){
		        $exemptVatVal=false;
		      }else{$exemptVatVal=true;}
		      break;
		      default:
		        $exemptVatVal=true;
		      } 

			  
			  $coin = '1';
                    switch ($currency->iso_code) {
                        case "ILS":
                        $coin = "1";
                        break;
                                                               
                        case "USD":
                        $coin = "2";
                        break;
                    
                        case "EUR":
                        $coin = "3";   
                        break; 
                    
                        case "GBP":
                        $coin = "4"; 
                        break; 
                    
                        case "AUD":
                        $coin = "5"; 
                        break; 
                    
                        case "CAD":
                        $coin = "6"; 
                        break; 
                    }
		     
		     
             // echo $this->context->language->iso_code;
		      //echo '<pre>';print_r($this->context->cart);die;


			$data = array();
 				$data = array(
 					'GroupPrivateToken' => $token,
 					'RedirectURL'=>$redirectURL,
 					'IPNURL'=>$ipnURL, 					
 					'Order' => $this->context->cart->id,
 					'Custom1' => $this->context->cart->id,		            
 					'CustomerLastName' => $this->context->customer->lastname,
 					'CustomerFirstName' => $this->context->customer->firstname,
 					'EmailAddress' => $customer->email,
 					'City' => $city,
 					'Zipcode' => intval($postcode),
 					'PhoneNumber' => $phone_mobile,
 					'Comments'=>$Customercomment,
 					'Address' => $address1,
 					'HideItemList'=>$hideitemlist,                //
 					'DocumentLanguage' => $invoiceLanguageVal, 					
 					'ExemptVAT' => $exemptVatVal,
 					'Discount' => $discountvalue,
 					'Items' => $items,
					'Currency'=>$coin,
					'Custom1'=> $this->context->language->iso_code,
					'Custom2'=>'en -'. Configuration::get('SecondProdGroupToken'),
 					);

			//echo"<pre>";print_r($data);die;
        	 $paymentUrl = $this->getPaymentUrl($service_url,$data);
         
       		if(isset($paymentUrl))
 			{
 	 				$window_type = Configuration::get('WindowType');
	 				$iframe_PopupHeight = Configuration::get('iFramePopupHeight');
	 				$iframe_PopupWidth = Configuration::get('iFramePopupWidth');


	 				$this->context->controller->addJS($path.'/js/jquery.fancybox.js');
                    $this->context->controller->addCSS($path.'/js/jquery.fancybox.css');
	 				if($window_type == 'redirect')
	 				{
	 					Tools::redirect($paymentUrl);
	 				}
	 				elseif($window_type == 'iframe')
	 				{			      		
			      		$iframe_execute =  '<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script><iframe onload="iFrameHeight()" id="blockrandom" name="iframe" src="'.$paymentUrl.'" width="'.$iframe_PopupWidth.'" height="'.$iframe_PopupHeight.'" frameborder="0" scrolling="yes"></iframe><script>function iFrameHeight() {var h = 0;if (!document.all) {h = document.getElementById("blockrandom").contentDocument.height;	document.getElementById("blockrandom").style.height = h + 60 + "px";} else if (document.all) {h = document.frames("blockrandom").document.body.scrollHeight;document.all.blockrandom.style.height = h + 20 + "px";}}</script><style>#module-iCredit-validation > iframe{}</style>';
			      		# Set the PrestaShop Smarty parameters
			      		$payment_title = Configuration::get('Title');
							$this->context->smarty->assign(array(
								'iframe_execute' => $iframe_execute,
								'payment_title' => $payment_title
							));


							# Display the template
							$this->setTemplate('iframe_page.tpl');
			      	}
	 				else
	 				{
				         //echo $value = '{"url":"'.$paymentUrl.'","window_type":"'.$window_type.'","width":"'.$iframe_PopupWidth.'","height":"'.$iframe_PopupHeight.'"}';
	 					echo '<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
					<script>
					function iFrameHeight() 
					{var h = 0;if (!document.all) {h = document.getElementById("blockrandom").contentDocument.height;	document.getElementById("blockrandom").style.height = h + 60 + "px";} else if (document.all) {h = document.frames("blockrandom").document.body.scrollHeight;document.all.blockrandom.style.height = h + 20 + "px";}}</script>
					
					<script type="text/javascript">
		      			$(document).ready(function(){
						
						
						var content = jQuery("#popup_val").html();

						$("#popup_val").hide();
						$.fancybox({
							"type" : "iframe",
							"href" : "'.$paymentUrl.'",
							"maxWidth":'.$iframe_PopupWidth.',
							"maxHeight" :'.$iframe_PopupHeight.',
							"onComplete" : function(){
								$("#fancybox-wrap").css({"top":"30px", "bottom":"auto"});
								
								}
						});
		      			});
</script>';
	 				}
 				
 				}			
			# Clear the cart
			//$cart->delete();
			
		}
		catch(Exception $e)
		{
			die($this->module->l('Payment failure', 'validation') . ', ' . $e->getMessage());
		}
	}

	public function getPaymentUrl($service_url,$data = array())
	{	
		$content = json_encode($data); 

		/*echo "<pre>";print_r($content);
		die;*/
		$curl = curl_init($service_url);

		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $content);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_TIMEOUT, 45);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER,array("Content-type: application/json"));			 
		$result = curl_exec($curl);
		
		$response = json_decode($result);
		//print_r($response);
		curl_close($curl);
		
      	$url_to_view = $response->URL;
		
	    return $url_to_view;
	}

}


